<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="Docutils 0.21.2: https://docutils.sourceforge.io/" />
<title>hg graft</title>
<link rel="stylesheet" href="../style.css" type="text/css" />
</head>
<body>
<div class="document" id="hg-graft">
<span id="hg-graft-1"></span>
<h1 class="title">hg graft</h1>
<h2 class="subtitle" id="copy-changes-from-other-branches-onto-the-current-branch">copy changes from other branches onto the current branch</h2>

<div class="contents htmlonly topic" id="contents">
<p class="topic-title"><a class="reference internal" href="#top">Contents</a></p>
<ul class="simple">
<li><a class="reference internal" href="#synopsis" id="toc-entry-1">Synopsis</a></li>
<li><a class="reference internal" href="#description" id="toc-entry-2">Description</a></li>
<li><a class="reference internal" href="#options" id="toc-entry-3">Options</a></li>
</ul>
</div>
<div class="section" id="synopsis">
<h1><a class="toc-backref" href="#contents">Synopsis</a></h1>
<pre class="literal-block">
hg graft [OPTION]... [-r REV]... REV...
</pre>
</div>
<div class="section" id="description">
<h1><a class="toc-backref" href="#contents">Description</a></h1>
<p>This command uses Mercurial's merge logic to copy individual
changes from other branches without merging branches in the
history graph. This is sometimes known as 'backporting' or
'cherry-picking'. By default, graft will copy user, date, and
description from the source changesets.</p>
<p>Changesets that are ancestors of the current revision, that have
already been grafted, or that are merges will be skipped.</p>
<p>If --log is specified, log messages will have a comment appended
of the form:</p>
<pre class="literal-block">
(grafted from CHANGESETHASH)
</pre>
<p>If --force is specified, revisions will be grafted even if they
are already ancestors of, or have been grafted to, the destination.
This is useful when the revisions have since been backed out.</p>
<p>If a graft merge results in conflicts, the graft process is
interrupted so that the current merge can be manually resolved.
Once all conflicts are addressed, the graft process can be
continued with the -c/--continue option.</p>
<p>The -c/--continue option reapplies all the earlier options.</p>
<div class="verbose docutils container">
<p>The --base option exposes more of how graft internally uses merge with a
custom base revision. --base can be used to specify another ancestor than
the first and only parent.</p>
<p>The command:</p>
<pre class="literal-block">
hg graft -r 345 --base 234
</pre>
<p>is thus pretty much the same as:</p>
<pre class="literal-block">
hg diff --from 234 --to 345 | hg import
</pre>
<p>but using merge to resolve conflicts and track moved files.</p>
<p>The result of a merge can thus be backported as a single commit by
specifying one of the merge parents as base, and thus effectively
grafting the changes from the other side.</p>
<p>It is also possible to collapse multiple changesets and clean up history
by specifying another ancestor as base, much like rebase --collapse
--keep.</p>
<p>The commit message can be tweaked after the fact using commit --amend .</p>
<p>For using non-ancestors as the base to backout changes, see the backout
command and the hidden --parent option.</p>
</div>
<div class="verbose docutils container">
<p>The experimental --to option allows grafting a revision in-memory,
independent of the working copy. Merge conflicts are not currently
supported, and the operation will be aborted if the configured tool
cannot handle the conflicts that might be encountered.</p>
<p>As the operation is performed in-memory, the on-disk files will not be
modified, and some hooks might not be run.</p>
</div>
<div class="verbose docutils container">
<p>Examples:</p>
<ul>
<li><p class="first">copy a single change to the stable branch and edit its description:</p>
<pre class="literal-block">
hg update stable
hg graft --edit 9393
</pre>
</li>
<li><p class="first">graft a range of changesets with one exception, updating dates:</p>
<pre class="literal-block">
hg graft -D &quot;2085::2093 and not 2091&quot;
</pre>
</li>
<li><p class="first">continue a graft after resolving conflicts:</p>
<pre class="literal-block">
hg graft -c
</pre>
</li>
<li><p class="first">show the source of a grafted changeset:</p>
<pre class="literal-block">
hg log --debug -r .
</pre>
</li>
<li><p class="first">show revisions sorted by date:</p>
<pre class="literal-block">
hg log -r &quot;sort(all(), date)&quot;
</pre>
</li>
<li><p class="first">backport the result of a merge as a single commit:</p>
<pre class="literal-block">
hg graft -r 123 --base 123^
</pre>
</li>
<li><p class="first">land a feature branch as one changeset:</p>
<pre class="literal-block">
hg up -cr default
hg graft -r featureX --base &quot;ancestor('featureX', 'default')&quot;
</pre>
</li>
</ul>
</div>
<p>See <a class="reference external" href="topic-revisions.html"><tt class="docutils literal">hg help revisions</tt></a> for more about specifying revisions.</p>
<p>Returns 0 on successful completion, 1 if there are unresolved files.</p>
</div>
<div class="section" id="options">
<h1><a class="toc-backref" href="#contents">Options</a></h1>
<table class="docutils option-list" frame="void" rules="none">
<col class="option" />
<col class="description" />
<tbody valign="top">
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-r</span>, <span class="option">--rev <var>&lt;REV[+]&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>revisions to graft</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--base <var>&lt;REV&gt;</var></span></kbd></td>
<td>base revision when doing the graft merge (ADVANCED)</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--to <var>&lt;VALUE&gt;</var></span></kbd></td>
<td>graft to this destination, in-memory (EXPERIMENTAL)</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-c</span>, <span class="option">--continue</span></kbd></td>
<td>resume interrupted graft</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--stop</span></kbd></td>
<td>stop interrupted graft</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--abort</span></kbd></td>
<td>abort interrupted graft</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-e</span>, <span class="option">--edit</span></kbd></td>
<td>invoke editor on commit messages</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--log</span></kbd></td>
<td>append graft info to log message</td></tr>
<tr><td class="option-group">
<kbd><span class="option">--no-commit</span></kbd></td>
<td>don't commit, just apply the changes in working directory</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-f</span>, <span class="option">--force</span></kbd></td>
<td>force graft</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-D</span>, <span class="option">--currentdate</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>record the current date as commit date</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-U</span>, <span class="option">--currentuser</span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>record the current user as committer</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-d</span>, <span class="option">--date <var>&lt;DATE&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>record the specified date as commit date</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-u</span>, <span class="option">--user <var>&lt;USER&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>record the specified user as committer</td></tr>
<tr><td class="option-group" colspan="2">
<kbd><span class="option">-t</span>, <span class="option">--tool <var>&lt;TOOL&gt;</var></span></kbd></td>
</tr>
<tr><td>&nbsp;</td><td>specify merge tool</td></tr>
<tr><td class="option-group">
<kbd><span class="option">-n</span>, <span class="option">--dry-run</span></kbd></td>
<td>do not perform actions, just print output</td></tr>
</tbody>
</table>
<p>[+] marked option can be specified multiple times</p>
</div>
</div>
</body>
</html>
